var http = require('http');
var fs = require('fs');
var querystring = require('querystring');
var child_process = require('child_process');

var html = fs.readFileSync('./nos.html');
var nosjs = fs.readFileSync('./nos.js');
var vizjs = fs.readFileSync('./viz.js');

// create the http server
http.createServer(function (req, res) {

    if (req.method == 'POST') {

        console.log("Got POST request");
        var fullBody = '';

        req.on('data', function(chunk) { fullBody += chunk.toString(); });

        req.on('end', function() {

            // parse the received body data
            var args = querystring.parse(fullBody);
            console.log(JSON.stringify(args));

            child_process.execFile("./while_nos_python/nos_tree.py", [args.command, args.state],
                function (err, stdout, stderr) {
                // console.log(err);
                // console.log(stderr);
                // console.log(stdout);
                // request ended -> do something with the data
                res.writeHead(200, "OK", {'Content-Type': 'text/plain'});
                res.end(stdout);
            });

        });

    } else {

        console.log("Got GET request for: " + req.url);

        // set up some routes
        switch(req.url) {
        case '/':
            // show html
            res.writeHead(200, "OK", {'Content-Type': 'text/html'});
            res.end(html);
            break;

        case '/nos.js':
            res.writeHead(200, "OK", {'Content-Type': 'text/plain'});
            res.end(nosjs)
            break;

        case '/viz.js':
            res.writeHead(200, "OK", {'Content-Type': 'text/plain'});
            res.end(vizjs)
            break;


        default:
            res.writeHead(404, "Not found", {'Content-Type': 'text/html'});
            res.end('<html><head><title>404 - Not found</title></head><body><h1>Found.</h1></body></html>');
            console.log("[404] " + req.method + " to " + req.url);
        };
    }

}).listen(8000);
