// Load the http module to create an http server.
var http = require('http');

var counter = 0;

var info = function (msg) {
    var now = new Date();
    return now.toLocaleTimeString() + " | counter=" + counter + " | " + msg + "\n";
};

var log = function (msg) {
    console.log(info(msg));
};


// Configure our HTTP server to respond with Hello World to all requests.
var server = http.createServer(function (request, response) {
    log("Start handling request");

    setTimeout(
        function () {
            log("Hi from closure");
            response.writeHead(200, {"Content-Type": "text/plain"});
            response.end(info("Hello World "));
        },
        10000);

    counter += 1

    log("Done handling request");

    // while (true) {}
});

// Listen on port 8000, IP defaults to 127.0.0.1
server.listen(8000);

// Put a friendly message on the terminal
log("Server running at http://127.0.0.1:8000/");
